package org.jboss.security.jacc;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import java.security.Principal;
import java.security.PrivilegedAction;
import java.util.Set;
import javax.security.auth.Subject;
import org.jboss.security.RunAsIdentity;
import org.jboss.security.SecurityAssociation;
import org.jboss.security.jacc.SubjectPolicyContextHandler;

class GetSubjectAction implements PrivilegedAction {
  static PrivilegedAction ACTION = new GetSubjectAction();
  
  public Object run() {
    Subject theSubject = null;
    Subject activeSubject = SecurityAssociation.getSubject();
    if (activeSubject != null) {
      Set principalsSet = null;
      RunAsIdentity callerRunAsIdentity = SecurityAssociation.peekRunAsIdentity(1);
      if (callerRunAsIdentity == null) {
        principalsSet = activeSubject.getPrincipals();
      } else {
        principalsSet = callerRunAsIdentity.getRunAsRoles();
      } 
      theSubject = new Subject(true, principalsSet, activeSubject.getPublicCredentials(), activeSubject.getPrivateCredentials());
    } else {
      RunAsIdentity callerRunAsIdentity = SecurityAssociation.peekRunAsIdentity(1);
      if (callerRunAsIdentity != null) {
        Set principalsSet = callerRunAsIdentity.getRunAsRoles();
        theSubject = new Subject(true, principalsSet, SubjectPolicyContextHandler.EMPTY_SET, SubjectPolicyContextHandler.EMPTY_SET);
      } 
    } 
    return theSubject;
  }
}
